# [RiskAdjustedLinearizations.jl](@id Home)

This package provides a user-friendly API for efficiently calculating risk-adjusted linearizations
of dynamic economic models. These linearizations are equivalent
to first-order perturbations around the stochastic steady state and are solved
by computing affine approximations.

## License

This content is released under the [MIT](https://opensource.org/licenses/MIT) License.

## Contents

```@contents
Pages = ["risk_adjusted_linearization.md", "numerical_algorithms.md", "example.md", "caching.md", "diagnostics.md", "tips.md"]
```
